/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: core_config.c 1124 2015-09-03 05:02:12Z ertl-honda $
 */

/*
 *        ¸⥸塼ARMѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "mp.h"

/*
 *  start.S ǤƱѿ
 */
volatile uint_t start_sync[TNUM_PRCID];

/*
 *  ץå¸ν
 */
void
core_initialize(void)
{
	APCB *p_apcb = get_my_p_apcb();
	uint32_t index = x_prc_index();

	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */
	p_apcb->excpt_nest_count = 1;

	/*
	 *  󥿥ƥѤΥåν
	 */
	p_apcb->istkpt = istkpt_table[index];

	/*
	 *  CPU㳰ϥɥơ֥ؤΥݥ󥿤ν
	 */
	p_apcb->p_exch_tbl = p_exch_table[index];
}

/*
 *  ץå¸νλ
 */
void
core_terminate(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}
}

/*
 * CPU㳰ϥɥν
 */
void
initialize_exception(void)
{
}

/*
 *  CPU㳰ȯΥ
 *
 *  CPU㳰ϥɥ椫顤CPU㳰ݥ󥿡p_excinfˤȤ
 *  ƸƤӽФȤǡCPU㳰ȯ򥷥ƥ˽Ϥ롥
 */
#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void *p_excinf)
{
}

#endif /* SUPPORT_XLOG_SYS */

/*
 *  㳰٥ľܼ¹ԤϥɥϿ
 */
void
x_install_exc(EXCNO excno, FP exchdr)
{
	*(((FP*)vector_ref_tbl) + excno) = exchdr;
}

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 * ̤㳰äν
 */

void
dump_excframe(exc_frame_t *p_exc_frame)
{
	ID prc_id = ID_PRC(x_prc_index());

	syslog_3(LOG_EMERG, "Processor %d : nest_count = %d, ipm = %d.",
			 prc_id, p_exc_frame->nest_count, p_exc_frame->ipm);
	syslog_4(LOG_EMERG, "Processor %d : r0 = 0x%08x, r1 = 0x%08x, r2 = 0x%08x",
			 prc_id, p_exc_frame->r0, p_exc_frame->r1, p_exc_frame->r2);
	syslog_3(LOG_EMERG, "Processor %d : r3 = 0x%08x, r12 = 0x%08x",
			 prc_id, p_exc_frame->r3, p_exc_frame->r12);
	syslog_4(LOG_EMERG, "Processor %d : lr = 0x%08x, pc = 0x%08x, cpsr = 0x%08x",
			 prc_id, p_exc_frame->lr, p_exc_frame->pc, p_exc_frame->cpsr);
}

void
default_exc_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "\nProcessor %d : Unregistered Exception occurs.", prc_id);
	dump_excframe((exc_frame_t*)p_excinf);
	target_exit();
}

void
default_undef_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "\nProcessor %d : Undef Exception occurs.", prc_id);
	dump_excframe((exc_frame_t*)p_excinf);
	target_exit();
}

void
default_swi_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "\nProcessor %d : SWI Exception occurs.", prc_id);
	dump_excframe((exc_frame_t*)p_excinf);
	target_exit();
}

void
default_prefetchabort_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "\nProcessor %d : Prefetch Abort Exception occurs.", prc_id);
	dump_excframe((exc_frame_t*)p_excinf);
	target_exit();
}

void
default_dataabort_handler(void *p_excinf){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "\nProcessor %d : Data Abort Exception occurs.", prc_id);
	dump_excframe((exc_frame_t*)p_excinf);
	target_exit();
}


#endif /* OMIT_DEFAULT_EXC_HANDLER */
