/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: safeg_load.c 1108 2015-07-07 14:40:43Z ertl-honda $
 */

#include <kernel.h>
#include <t_stdlib.h>

static bool_t run_trust[TNUM_PRCID];
static SYSUTM trust_start_time[TNUM_PRCID];
static SYSUTM trust_total_time[TNUM_PRCID];
static SYSUTM load_start_time[TNUM_PRCID];

/*
 *  
 */
void
safeg_load_init(intptr_t exinf)
{
	ID prcid;
	uint_t index;

	sil_get_pid(&prcid);
	index = prcid - 1;

	run_trust[index] = true;

	if (sns_ker()) {
		/* J[lNO */
		trust_start_time[index] = 0;
		load_start_time[index] = 0;
	}
	else {
		/* J[lN */
		get_utm(&(trust_start_time[index]));
		load_start_time[index] = trust_start_time[index];
	}

	trust_total_time[index] = 0;
}

/*
 *  CPUp̎擾
 */
void
safeg_load_info(ID prcid, uint32_t *p_trust_load, uint32_t *p_nontrust_load)
{
	SYSUTM cur_time;
	SYSUTM trust_total;
	uint_t index = prcid - 1;

	get_utm(&cur_time);
	trust_total = trust_total_time[index] + (cur_time - trust_start_time[index]);

	*p_trust_load = (trust_total/10)/((cur_time - load_start_time[index])/1000);
	*p_nontrust_load = 100 - *p_trust_load;
}

/*
 *  ݂̓ŌĂяo֐
 */
void
safeg_load_int(void){
	ID prcid;
	uint_t index;

	sil_get_pid(&prcid);
	index = prcid - 1;

	if (!run_trust[index]) {
		run_trust[index] = true;
		get_utm(&(trust_start_time[index]));
	}
}

/*
 *  AChɌĂяo֐
 */
void
safeg_load_idle(void){
	SYSUTM time;
	ID prcid;
	uint_t index;

	sil_get_pid(&prcid);
	index = prcid - 1;
	
	run_trust[index] = false;
	get_utm(&time);
	trust_total_time[index] += time - trust_start_time[index];
}
