/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel    
 * 
 *  Copyright (C) 2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: ns16550.h 1019 2013-07-11 13:29:21Z ertl-honda $
 */

/*
 *   IMXUART  ʰSIOɥ饤
 */
#ifndef TOPPERS_IMXUART_H
#define TOPPERS_IMXUART_H


#define USE_UART2

#ifdef TARGET_USE_UART1
#define INHNO_SIO1   DIC_IRQNO_UART1
#define INTNO_SIO1   DIC_IRQNO_UART1
#elif defined(TARGET_USE_UART2)
#define INHNO_SIO1   DIC_IRQNO_UART2
#define INTNO_SIO1   DIC_IRQNO_UART2
#elif defined(TARGET_USE_UART3)
#define INHNO_SIO1   DIC_IRQNO_UART3
#define INTNO_SIO1   DIC_IRQNO_UART3
#endif /* TARGET_USE_UART1 */

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		1		/* ݡȤ륷ꥢI/OݡȤο */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 *  ͥ뵯ưѤν(sys_putcѤ뤿)
 */
extern void sio_init(void);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void sio_pol_putc(char c, ID siopid);

/*
 *  SIOɥ饤Фν롼
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB  *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void sio_isr(intptr_t exinf);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);


/*
 *  ưΥ٥Ѥν
 */
extern void sio_low_init(ID siopid);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_IMXUART_H */
