/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 *
 *  Copyright (C) 2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  @(#) $Id: target_support.S 1019 2013-07-11 13:29:21Z ertl-honda $
 */

/*
 *  åȰ¸⥸塼 ֥ARMѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"

#ifdef TOPPERS_SAFEG_SECURE

    ATEXT
    AALIGN(2)
    AGLOBAL(init_diag_reg)
ALABEL(init_diag_reg)
	mrc p15, 0, r0, c0, c0, 0	/* read main ID register */
	and r1, r0, #0x00f00000		/* variant */
	and r2, r0, #0x0000000f		/* revision */

	mrc p15, 0, r3, c15, c0, 1	/* read diagnostic register */

	/* ARM_ERRATA_742230 */
	cmp r2, #0x22		/*  up to r2p2 */
	orrle r3, r3, #1 << 4

	/* ARM_ERRATA_742231 */
	teq   r2, #0x20		/* in r2p0 */
	teqne r2, #0x21		/* in r2p1 */
	teqne r2, #0x22		/* in r2p2 */
	orreq r3, r3, #1 << 12
	orreq r3, r3, #1 << 22

	/* ARM_ERRATA_743622 */
	teq   r1, #0x00200000 /* in r2p */
	orreq	r3, r3, #1 << 6

	/* ARM_ERRATA_751472 */
	cmp r2, #0x30			/* prior to r3p0 */
	orrlt	r3, r3, #1 << 11

	/* ARM_ERRATA_794072 */
	orr	r3, r3, #1 << 4		@ set bit #4

	/* CONFIG_ARM_ERRATA_761320 */
	cmp	r2, #0x40			/* prior to r4p0 */
	orrlt	r3, r3, #1 << 21

	mcr p15, 0, r3, c15, c0, 1	/* write diagnostic register */
	bx	lr
#endif /* TOPPERS_SAFEG_SECURE */

